# Sync

* Follow chromium-devtools-workflow to download and compile a version of chromium devtools.
* Copy `out/Default/Resources` folder into this directory
* Strip `.map` files
* To make it work on firefox Change the order in `screencast-meta.js` to a lower figure

```js
Common.AppProvider.registerAppProvider({
    async loadAppProvider() {
        const Screencast = await loadScreencastModule();
        return Screencast.ScreencastApp.ScreencastAppProvider.instance();
    },
    order: 10,
    condition: undefined,
});
```
to
```js
Common.AppProvider.registerAppProvider({
    async loadAppProvider() {
        const Screencast = await loadScreencastModule();
        return Screencast.ScreencastApp.ScreencastAppProvider.instance();
    },
    order: -1,
    condition: undefined,
});
```

* Modify extensionserver.js

```kAllowedOrigins = []```

* Modify `ScreencastApp.js`

```js
    modelAdded(screenCaptureModel) {
        if (this._screenCaptureModel) {
            return;
        }
        this._screenCaptureModel = screenCaptureModel;
        this._toggleButton.setEnabled(true);
        this._screencastView = new ScreencastView(screenCaptureModel);
        if (this._rootSplitWidget) {
            this._rootSplitWidget.setMainWidget(this._screencastView);
        }
        this._screencastView.initialize();
        this._onScreencastEnabledChanged();
+       this._rootSplitWidget.hideSidebar();
    }
```

* Modify `InspectorView.js` 

```js
- this.setMinimumSize(240, 72);
+ this.setMinimumSize(5, 72);
```
